"""
filename: regEx.py
Author: Mark Clarkson
Date: July, 2012
Description: A simple program to introduce regular expressions
"""

# Step 1 - Read through the program, starting from the main menu

# Step 2 - Run the program, see if it does what you expect

# Step 3 - In the checkLower function, remove the two # symbols
# and put something appropriate in between the speech marks

# Step 4 - Test it!

# Step 5 - In the checkDigit function, remove the two # symbols
# and put something appropriate on that whole line

# Step 6 - Test it!

#import the Regular Expression module - this should always be right at the top
import re


#define any functions or procedures


#check for upper case letters, return True or False
def checkUpper(string):
    found = False
    if re.search("[A-Z]",string): #Scan through looking for a capital letter
        found = True
    return found


#check for lower case letters, return True or False
def checkLower(string):
    found = False
#    if re.search("<put something here>",string): #Scan through looking for a lower case letter
#        found = True
    return found


#check for digits, return True or False
def checkDigit(string):
    found = False
#    <put something here> #Scan through looking for a capital letter
#        found = True
    return found


#main program
def mainLoop():
    #get a postcode from the user
    postcode = input("\n\nEnter a postcode: ")
        
    #check for upper cse, lower case and digits
    upper = checkUpper(postcode)
    lower = checkLower(postcode)
    digit = checkDigit(postcode)

    #display an appropriate message
    if upper == True and digit == True and lower == False:
        print("This postcode might be valid.")
    elif lower == True:
        print("Error, postcode contains lower case letters")
    elif upper == False:
        print("Error, postcode contains no letters")
    elif digit == False:
        print("Error, postcode contains no digits")
    else:
        print("Unspecified error. Go figure!")


#function to find out whether to run the program again
def goAgain():
    while True: #repeat forever (automatically exits on a return statement)
        choice = input("Test another postcode? (Y/N): ")
        if choice == "Y":
            return True
        elif choice == "N":
            print("Goodbye!")
            return False
        else:
            print("Error, invalid choice.\n\n")

#MAIN METHOD

print("Welcome to the postcode checker\n\n")
keepGoing = True
while keepGoing == True:
    mainLoop()
    keepGoing = goAgain()
 
