"""
Filename: fileHandling01.py
Author: Mark Clarkson
Date: July, 2012
Description: A basic introduction to file handling
"""

#write some test data to a file
def writeFile():
    #open a file called 'temp.txt' in write mode
    file = open("temp.txt","w")

    #repeat 10 times
    for number in range(1,11):
        
        #create a string to write to the file
        line = "This is test number " + str(number) + "\n"

        #write the line to the file
        file.write(line) 

    #close the file
    file.close() 


#display the entire contents of a file
def readWholeFile():
    #open a file called 'temp.txt' in read mode
    file = open("temp.txt","r")
    
    #read and print the entire contents of the file in one go
    print(file.read())
    
    #close the file
    file.close()


#display the contents of a file line by line
def readFileLineByLine():
    #open a file called 'temp.txt' in read mode
    file = open("temp.txt","r")
    
    #read and print one line at a time until file finished
    line = file.readline()
    while line != "":
        print(line)
        line = file.readline()
        
    #close file when finished
    file.close()


#MAIN METHOD

writeFile()
#readWholeFile()
#readFileLineByLine()
    
